#include "MyGLBuilderGeometry3DVisitor.h"
#include "Icosahedron.h"
#include "GL_Icosahedron.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

MyGLBuilderGeometry3DVisitor::MyGLBuilderGeometry3DVisitor()
: GLBuilderGeometry3DVisitor()
{
  // Define new enter function for Icosahedron. Note that it is the instanciation of a template method.
  defineNewEnterFunction(&MyGLBuilderGeometry3DVisitor::enterIcosahedron);
}

void MyGLBuilderGeometry3DVisitor::enterIcosahedron(Icosahedron *I) const
{
  GL::SFNode GI = globalVariables->getNode(I);
  if (GI == 0)
  {
    GI = new GL::Icosahedron();
    GI->setX3DReference(I);
    globalVariables->addCoupleNode(I, GI);
  }
  globalVariables->pushNode(GI);
}

}
}
