#include "InfoReaderGroupingVisitor.h"
#include "Info.h"
#include "Price.h"
#include "Modeler.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

InfoReaderGroupingVisitor::InfoReaderGroupingVisitor()
: GroupingVisitor()
{
  // WalkOn functions.
  defineNewEnterFunction(&InfoReaderGroupingVisitor::enterInfo);
  defineNewEnterFunction(&InfoReaderGroupingVisitor::enterPrice);
  defineNewEnterFunction(&InfoReaderGroupingVisitor::enterModeler);    
}

InfoReaderGroupingVisitor::~InfoReaderGroupingVisitor()
{
}

void InfoReaderGroupingVisitor::enterInfo(Info *I) const
{
  cout << "Informations relative to the scene:"<< endl;
}

void InfoReaderGroupingVisitor::enterPrice(Price *P) const
{
  cout << "  price = " << P->getPrice() << " " << P->getMoney() << endl;
}

void InfoReaderGroupingVisitor::enterModeler(Modeler *M) const
{
  cout << "  realized on the " << M->getName() << " modeler" << endl;
}

}
}
