#include "MeshTransformComputerCoreVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

MeshTransformComputerCoreVisitor::MeshTransformComputerCoreVisitor()
{
  // Enter functions.
  defineNewEnterFunction(&MeshTransformComputerCoreVisitor::enterMesh);
  defineNewEnterFunction(&MeshTransformComputerCoreVisitor::enterTransform);
  
  // Leave functions.
  defineNewLeaveFunction(&MeshTransformComputerCoreVisitor::leaveX3DGroupingNode);
  
  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<MeshTransformComputerGlobalVariables>();
}

MeshTransformComputerCoreVisitor::~MeshTransformComputerCoreVisitor()
{
}

void MeshTransformComputerCoreVisitor::enterMesh(Mesh *M) const
{
  cout << "enter Mesh" << endl;
  cout << "Transform:" << endl << globalVariables->getMatrix() << endl;
  cout << "  number of vertices = " << M->getVertices().size() << endl;
  for (Mesh::MVertex::const_iterator it = M->getVertices().begin(); it != M->getVertices().end(); ++it)
    cout << (*it)->data().getPoint() << endl;
}

void MeshTransformComputerCoreVisitor::enterTransform(Transform *T) const
{
  globalVariables->pushMatrix(T->getTransform());
}

void MeshTransformComputerCoreVisitor::leaveX3DGroupingNode(X3DGroupingNode *N) const
{
  globalVariables->popMatrix();
}

}
}
