#include "MeshTransformComputer.h"

#include <X3DTK/x3dscenegraph.h>
#include <X3DTK/meshbuilder.h>

#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: meshtransformcomputer input" << endl;
    exit(0);
  }
  
  // DefaultLoader to load the default X3D Nodes.
  X3D::Loader *loader = new X3D::Loader();
  // Instanciation of the new MeshBuilder.
  X3D::MeshBuilder *meshbuilder = new X3D::MeshBuilder();
  // Instanciation of the new MeshTransformComputer.
  MESH::MeshTransformComputer *mtc = new MESH::MeshTransformComputer();  
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1], false);
  MESH::Scene *ms = meshbuilder->build(s);
  
  mtc->print(ms);  
  
  return 1;
}
