////////////////////////////////////////////////////////////////////////////////
///                            MeshDrawerCoreVisitor.h                       ///
////////////////////////////////////////////////////////////////////////////////

#ifndef MESH_DRAWER_COREVISITOR_H
#define MESH_DRAWER_COREVISITOR_H

#include <X3DTK/meshscenegraph.h>
#include "MeshDrawerGlobalVariables.h"

namespace X3DTK {
namespace MESH {

class Transform;

/// Visitor for the Core component of the MeshDrawer processor.

class MeshDrawerCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  MeshDrawerCoreVisitor();

  /// Enters a Mesh.
  virtual void enterMesh(Mesh *M) const;

  /// Enters a Transform : push matrix
  virtual void enterTransform(Transform *T) const;

  /// Leaves a Transform : pop matrix
  virtual void leaveTransform(Transform *T) const;

protected:
  MeshDrawerGlobalVariables *globalVariables;
};

}
}

#endif
