#include "MyStructureComputer.h"

#include <X3DTK/x3dscenegraph.h>
#include <X3DTK/meshbuilder.h>
#include <X3DTK/memreleaser.h>

#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: MyStructureComputer input" << endl;
    exit(0);
  }
  
  // DefaultLoader to load the default X3D Nodes.
  X3D::Loader *loader = new X3D::Loader();
  // Instanciation of the new MeshBuilder.
  X3D::MeshBuilder *meshbuilder = new X3D::MeshBuilder();
  // Instanciation of the new MyStructureComputer.
  MESH::MyStructureComputer *msc = new MESH::MyStructureComputer();  
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1], false);
  MESH::Scene *ms = meshbuilder->build(s);
  MySimpleMesh *mesh = msc->compute(ms);  
 
  mesh->print();
  
  return 1;
}
