////////////////////////////////////////////////////////////////////////////////
//                            GLNormalRenderer.h                              //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLNORMALRENDERER_H
#define GLNORMALRENDERER_H

#include "GLNormalRendererGlobalVariables.h"

#include <X3DTK/kernel.h>

namespace X3DTK {
namespace GL {

/// GLNormalRenderer module.

class NormalRenderer
{
public:
  /// Constructor.
  NormalRenderer();
  /// Destructor.
  virtual ~NormalRenderer();
  
  void setNormalLength(float value);
  void setComponentVisitor(X3DComponentVisitor *component);
    
  /// Renders a GLScene.
  virtual void render(SFNode N) const;

protected:
  DFS *dfs;
  NormalRendererGlobalVariables *globalVariables;
};

}
}

#endif
