////////////////////////////////////////////////////////////////////////////////
//                            GLIcosahedron.h                                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLICOSAHEDRON_H
#define GLICOSAHEDRON_H

#include <X3DTK/kernel.h>

namespace X3DTK {
namespace GL {

// Class providing a implementation of the X3DGLNode corresponding to the X3DNode 
// Icosahedron.

class Icosahedron : public X3DGeometry3DNode
{
public:
  // Constructor.
  Icosahedron();
  // Clones the node.
  virtual SFNode clone() const;

  /// Updates the attributes of the node.
  virtual void update();
  /// Draws the node.
  virtual void render() const;

protected:
  // Copy constructor.
  Icosahedron(const Icosahedron &I); 

private:  
  MFVec3f _vertices;
  short _indexes[12][5];
  MFVec3f _normal; 
};

}
}

#endif
