#include "MyGLBuilderGeometry3DVisitor.h"
#include "Icosahedron.h"
#include "GLIcosahedron.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

MyGLBuilderGeometry3DVisitor::MyGLBuilderGeometry3DVisitor()
: GLBuilderGeometry3DVisitor()
{
  // Define new enter function for FCylinder.
  defineNewEnterFunction<MyGLBuilderGeometry3DVisitor, Icosahedron>(&MyGLBuilderGeometry3DVisitor::enterIcosahedron);
}

void MyGLBuilderGeometry3DVisitor::enterIcosahedron(Icosahedron *I) const
{
  // Creation of the GL::Icosahedron.
  GL::Icosahedron *GI = new GL::Icosahedron();
  GI->setX3DReference(I);
  globalVariables->getTop()->addChild(GI);
  globalVariables->pushNode(GI);
}

}
}
