#include "InfoReader.h"
#include "MyDFS.h"
#include "InfoReaderGroupingVisitor.h"

namespace X3DTK {
namespace X3D {

InfoReader::InfoReader()
{
  dfs = new MyDFS();
  
  dfs->setComponentVisitor(new InfoReaderGroupingVisitor());
}

InfoReader::~InfoReader()
{
  delete dfs;
}

void InfoReader::setComponentVisitor(X3DComponentVisitor *component)
{
  dfs->setComponentVisitor(component);
}

void InfoReader::read(SFNode N)
{
  dfs->traverse(N);
}

}
}
