#include "MyDFSGroupingWalker.h"
#include "Info.h"
#include "Price.h"
#include "Modeler.h"

#include <iostream>
using namespace std;

namespace X3DTK {
namespace X3D {

MyDFSGroupingWalker::MyDFSGroupingWalker()
: DefaultDFSGroupingWalker()
{
  defineNewWalkingFunction<MyDFSGroupingWalker, Info>(&MyDFSGroupingWalker::walkInfo);
}

MyDFSGroupingWalker::~MyDFSGroupingWalker()
{
}

void MyDFSGroupingWalker::walkInfo(Info *I) const
{
  nodeVisitingProxy->enter(I);
  
  SFNode N = I->getPrice();
  if ((N != 0) && (nodeVisitingProxy->walkOn(I, N)))
    nodeWalkingProxy->walk(N);
  
  N = I->getModeler();
  if ((N != 0) && (nodeVisitingProxy->walkOn(I, N)))
    nodeWalkingProxy->walk(N);  
  
  nodeVisitingProxy->leave(I);
}

}
}
