#include "MyGroupingCreator.h"
#include "Info.h"
#include "Price.h"
#include "Modeler.h"

namespace X3DTK {
namespace X3D {

MyGroupingCreator::MyGroupingCreator()
: DefaultGroupingCreator()
{
  // Defines the new creation functions for the new nodes.
  defineNewCreationFunction<MyGroupingCreator>("Info", &MyGroupingCreator::createInfo);
  defineNewCreationFunction<MyGroupingCreator>("Price", &MyGroupingCreator::createPrice);
  defineNewCreationFunction<MyGroupingCreator>("Modeler", &MyGroupingCreator::createModeler);  
}

SFNode MyGroupingCreator::createInfo() const
{
  return new Info();
}

SFNode MyGroupingCreator::createPrice() const
{
  return new Price();
}

SFNode MyGroupingCreator::createModeler() const
{
  return new Modeler();
}

}
}
