/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            InterpolationCreator.h                          //
////////////////////////////////////////////////////////////////////////////////

#ifndef INTERPOLATIONCREATOR_H
#define INTERPOLATIONCREATOR_H

#include "X3DComponentCreator.h"

namespace X3DTK {
namespace X3D {

class ColorInterpolator;
class CoordinateInterpolator;
class CoordinateInterpolator2D;
class NormalInterpolator;
class OrientationInterpolator;
class PositionInterpolator;
class PositionInterpolator2D;
class ScalarInterpolator;

/// Concrete component Creator for the Interpolator component defining the  
/// X3D nodes.

class InterpolationCreator : public X3DComponentCreator
{
public:
  /// Constructor.
  InterpolationCreator();
  /// Destructor.
  virtual ~InterpolationCreator();
  
  /// Creates a ColorInterpolator.
  ColorInterpolator *createColorInterpolator() const;
  /// Creates a CoordinateInterpolator.
  CoordinateInterpolator *createCoordinateInterpolator() const;
  /// Creates a CoordinateInterpolator2D.
  CoordinateInterpolator2D *createCoordinateInterpolator2D() const;      
  /// Creates a NormalInterpolator.
  NormalInterpolator *createNormalInterpolator() const;
  /// Creates a OrientationInterpolator.
  OrientationInterpolator *createOrientationInterpolator() const;
  /// Creates a PositionInterpolator.
  PositionInterpolator *createPositionInterpolator() const;
  /// Creates a PositionInterpolator2D.
  PositionInterpolator2D *createPositionInterpolator2D() const;      
  /// Creates a ScalarInterpolator.
  ScalarInterpolator *createScalarInterpolator() const;
};

}
}

#endif
