/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            Platform.h                                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef PLATFORM_H
#define PLATFORM_H

// Defines and includes for MSVC
#ifdef WIN32
  #ifdef X3DTK_EXPORTS
    #define X3DTK_API __declspec(dllexport)
  #else
    #define X3DTK_API __declspec(dllimport)  
  #endif
  
  #pragma pointers_to_members(full_generality, multiple_inheritance)
  
  #include <direct.h>
  #include <windows.h>
  #include <algorithm>

  #pragma warning (disable : 4251)

#else
  #include <unistd.h>
#endif    

// Defines and includes for sgi and apple
#ifdef __sgi
  #include <math.h>
#else
  #include <cmath>
  #ifdef __APPLE__
    #define sinf sin
    #define cosf cos
  #endif
#endif  

//#include "CLog.h"

#endif
