/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            RenderingCreator.h                              //
////////////////////////////////////////////////////////////////////////////////

#ifndef RENDERINGCREATOR_H
#define RENDERINGCREATOR_H

#include "X3DComponentCreator.h"

namespace X3DTK {
namespace X3D {

class Color;
class ColorRGBA;
class Coordinate;
class IndexedLineSet;
class Normal;
class PointSet;
class TriangleFanSet;
class TriangleSet;
class TriangleStripSet;

/// Concrete component Creator for the Rendering component defining the  
/// X3D nodes.

class RenderingCreator : public X3DComponentCreator
{
public:
  /// Constructor.
  RenderingCreator();
  /// Destructor.
  virtual ~RenderingCreator();
  
  /// Creates a Color.
  Color *createColor() const;
  /// Creates a ColorRGBA.
  ColorRGBA *createColorRGBA() const;
  /// Creates a Coordinate.
  Coordinate *createCoordinate() const;
  /// Creates a IndexedLineSet.
  IndexedLineSet *createIndexedLineSet() const;
  /// Creates a Normal.
  Normal *createNormal() const;
  /// Creates a PointSet.
  PointSet *createPointSet() const;
  /// Creates a TriangleFanSet.
  TriangleFanSet *createTriangleFanSet() const;
  /// Creates a TriangleSet.
  TriangleSet *createTriangleSet() const;
  /// Creates a TriangleStripSet.
  TriangleStripSet *createTriangleStripSet() const;
};

}
}

#endif
