/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//  generated by script                                                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DTK_X3DSCENEGRAPH_H
#define X3DTK_X3DSCENEGRAPH_H

//base
#include "private/X3DSceneGraphTypes.h"

//componentActors
#include "private/CoreVisitor.h"
#include "private/DFSCoreWalker.h"
#include "private/DFSGeometry3DWalker.h"
#include "private/DFSGraphTraversal.h"
#include "private/DFSGroupingWalker.h"
#include "private/DFSInterpolationWalker.h"
#include "private/DFSLightingWalker.h"
#include "private/DFSNURBSWalker.h"
#include "private/DFSRenderingWalker.h"
#include "private/DFSShapeWalker.h"
#include "private/DFSTexturingWalker.h"
#include "private/Geometry3DVisitor.h"
#include "private/GroupingVisitor.h"
#include "private/InterpolationVisitor.h"
#include "private/LightingVisitor.h"
#include "private/NURBSVisitor.h"
#include "private/RenderingVisitor.h"
#include "private/ShapeVisitor.h"
#include "private/TexturingVisitor.h"

//nodes

//Core
#include "private/Scene.h"
#include "private/X3DNode.h"
#include "private/X3DObject.h"

//Geometry3D
#include "private/Box.h"
#include "private/Cone.h"
#include "private/Cylinder.h"
#include "private/IndexedFaceSet.h"
#include "private/Sphere.h"

//Grouping
#include "private/Group.h"
#include "private/StaticGroup.h"
#include "private/Switch.h"
#include "private/Transform.h"
#include "private/X3DBoundedObject.h"
#include "private/X3DChildNode.h"
#include "private/X3DGroupingNode.h"

//Interpolation
#include "private/ColorInterpolator.h"
#include "private/CoordinateInterpolator2D.h"
#include "private/CoordinateInterpolator.h"
#include "private/NormalInterpolator.h"
#include "private/OrientationInterpolator.h"
#include "private/PositionInterpolator2D.h"
#include "private/PositionInterpolator.h"
#include "private/ScalarInterpolator.h"
#include "private/X3DInterpolatorNode.h"

//Lighting
#include "private/DirectionalLight.h"
#include "private/PointLight.h"
#include "private/SpotLight.h"
#include "private/X3DLightNode.h"

//NURBS
#include "private/Contour2D.h"
#include "private/ContourPolyline2D.h"
#include "private/CoordinateDeformer.h"
#include "private/NurbsCurve2D.h"
#include "private/NurbsCurve.h"
#include "private/NurbsGroup.h"
#include "private/NurbsPositionInterpolator.h"
#include "private/NurbsSurface.h"
#include "private/NurbsTextureSurface.h"
#include "private/TrimmedSurface.h"
#include "private/X3DParametricGeometryNode.h"

//Rendering
#include "private/Color.h"
#include "private/ColorRGBA.h"
#include "private/Coordinate.h"
#include "private/IndexedLineSet.h"
#include "private/Normal.h"
#include "private/PointSet.h"
#include "private/TriangleFanSet.h"
#include "private/TriangleSet.h"
#include "private/TriangleStripSet.h"
#include "private/X3DColorNode.h"
#include "private/X3DComposedGeometryNode.h"
#include "private/X3DCoordinateNode.h"
#include "private/X3DGeometricPropertyNode.h"
#include "private/X3DGeometry3DNode.h"
#include "private/X3DGeometryNode.h"
#include "private/X3DNormalNode.h"

//Shape
#include "private/Appearance.h"
#include "private/FillProperties.h"
#include "private/LineProperties.h"
#include "private/Material.h"
#include "private/Shape.h"
#include "private/X3DAppearanceChildNode.h"
#include "private/X3DAppearanceNode.h"
#include "private/X3DMaterialNode.h"
#include "private/X3DShapeNode.h"

//Texturing
#include "private/ImageTexture.h"
#include "private/TextureCoordinate.h"
#include "private/X3DTexture2DNode.h"
#include "private/X3DTextureCoordinateNode.h"
#include "private/X3DTextureNode.h"
#include "private/X3DTextureTransformNode.h"

//componentCreators
#include "private/AbstractCreator.h"
#include "private/CoreCreator.h"
#include "private/Geometry3DCreator.h"
#include "private/GroupingCreator.h"
#include "private/InterpolationCreator.h"
#include "private/LightingCreator.h"
#include "private/NURBSCreator.h"
#include "private/RenderingCreator.h"
#include "private/ShapeCreator.h"
#include "private/TexturingCreator.h"
#include "private/CreationFunction.h"
#include "private/Creator.h"
#include "private/libXMLLoader.h"
#include "private/Loader.h"
#include "private/QLoader.h"
#include "private/X3DComponentCreator.h"
#include "private/X3DLoader.h"
#include "private/XercesLoader.h"

#endif
