/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            MeshTransform.h                                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef MESHTRANSFORM_H
#define MESHTRANSFORM_H

#include "MESH_X3DGroupingNode.h"

namespace X3DTK {
namespace MESH {

/// Class providing a Transform node for the Mesh graph scene.

class Transform : public X3DGroupingNode
{
public:
  /// Constructor.
  Transform();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~Transform();
  
  /// Sets the transformation.
  void setTransform(const SFMatrix34f &M);
  
  /// Gets the transformation.
  const SFMatrix34f &getTransform() const;
  
protected:
  /// Copy constructor.
  Transform(const Transform &T);
  
private:
  SFMatrix34f _transform;  
};

}
}

#endif
