#include "NURBSCreator.h"
#include "Contour2D.h"
#include "ContourPolyline2D.h"
#include "NurbsCurve.h"
#include "NurbsCurve2D.h"
#include "NurbsGroup.h"
#include "NurbsPositionInterpolator.h"
#include "NurbsSurface.h"
#include "NurbsTextureSurface.h"
#include "TrimmedSurface.h"

namespace X3DTK {
namespace X3D {

NURBSCreator::NURBSCreator()
{
  defineComponentName("NURBS", "X3D");

  defineNewNode<Contour2D>();
  defineNewNode<ContourPolyline2D>();
  defineNewNode<NurbsCurve>();
  defineNewNode<NurbsCurve2D>();
  defineNewNode<NurbsGroup>();
  defineNewNode<NurbsPositionInterpolator>();
  defineNewNode<NurbsSurface>();
  defineNewNode<NurbsTextureSurface>();
  defineNewNode<TrimmedSurface>();
}

NURBSCreator::~NURBSCreator()
{
}

}
}
