/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            ShapeCreator.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef SHAPECREATOR_H
#define SHAPECREATOR_H

#include "X3DComponentCreator.h"

namespace X3DTK {
namespace X3D {

class Appearance;
class FillProperties;
class LineProperties;
class Material;
class Shape;

/// Concrete component Creator for the  Shape component defining the  
/// X3D nodes.

class ShapeCreator : public X3DComponentCreator
{
public:
  /// Constructor.
  ShapeCreator();
  /// Destructor.
  virtual ~ShapeCreator();
  
  /// Creates an Appearance.
  Appearance *createAppearance() const;
  /// Creates a FillProperties.
  FillProperties *createFillProperties() const;
  /// Creates a LineProperties.
  LineProperties *createLineProperties() const;
  /// Creates a Material.
  Material *createMaterial() const;
  /// Creates a Shape.
  Shape *createShape() const;
};

}
}

#endif
