#include "DFSGraphTraversal.h"
#include "DFSCoreWalker.h"
#include "DFSGeometry3DWalker.h"
#include "DFSGroupingWalker.h"
#include "DFSRenderingWalker.h"
#include "DFSShapeWalker.h"
#include "DFSTexturingWalker.h"
#include "DFSInterpolationWalker.h"
#include "DFSLightingWalker.h"
#include "DFSNURBSWalker.h"

namespace X3DTK {
namespace X3D {

DFSGraphTraversal::DFSGraphTraversal()
: GraphTraversal()
{
  setComponentWalker(new DFSCoreWalker());
  setComponentWalker(new DFSGeometry3DWalker());
  setComponentWalker(new DFSGroupingWalker());
  setComponentWalker(new DFSRenderingWalker());
  setComponentWalker(new DFSShapeWalker());
  setComponentWalker(new DFSTexturingWalker());
  setComponentWalker(new DFSInterpolationWalker());
  setComponentWalker(new DFSLightingWalker());
  setComponentWalker(new DFSNURBSWalker());
}

DFSGraphTraversal::~DFSGraphTraversal()
{
}

void DFSGraphTraversal::setComponentWalker(X3DComponentWalker *component)
{
  GraphTraversal::setComponentWalker(component);
}

}
}
