#include "ImageTexture.h"

namespace X3DTK {
namespace X3D {

ImageTexture::ImageTexture()
: X3DTexture2DNode()
{
  defineTypeName("ImageTexture", "Texturing");
}

ImageTexture::ImageTexture(const ImageTexture &N)
: X3DTexture2DNode(N)
{
}

SFNode ImageTexture::clone() const
{
  return new ImageTexture(*this);
}

ImageTexture::~ImageTexture()
{
}
  
void ImageTexture::setUrl(const MFString &url)
{
  _url = url;
}

void ImageTexture::load(const X3DFileElement *element)
{
  X3DTexture2DNode::load(element);

  int index;
  index = element->getIndexAttribute("url");
  if (index != -1)
    _url = MFString(element->getAttribute(index));
  
  char *cwd = (char *)malloc(255);
  getcwd(cwd, 255);  
    
  for (MFString::iterator it = _url.begin(); it != _url.end(); ++it)
    *it = SFString(cwd) + "/" + *it;
}

SFString ImageTexture::write() const
{
  SFString attr;
  attr += X3DTexture2DNode::write();
  
  if (!_url.empty())
    attr += " url=\'" + toSFString(_url) + "\'";
        
  return attr;
}

}
}
