#include "MeshNodeListBuilder.h"
#include "MeshNodeListBuilderCoreVisitor.h"
#include "MESH_DFSGraphTraversal.h"

using namespace std;

namespace X3DTK {
namespace MESH {

NodeListBuilder::NodeListBuilder()
{
  globalVariables = GVManager::getInstanceOf<NodeListBuilderGlobalVariables>();
  
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new NodeListBuilderCoreVisitor());
}

NodeListBuilder::~NodeListBuilder()
{
  GVManager::removeInstanceOf<NodeListBuilderGlobalVariables>();
  
  delete graphTraversal;
}
  
void NodeListBuilder::buildLists(MESH::Scene *S)
{
  globalVariables->init();
  graphTraversal->traverse(S);
}
  
}
}
