#include "BBoxUpdater.h"
#include "BBoxUpdaterCoreVisitor.h"
#include "BBoxUpdaterGeometry3DVisitor.h"
#include "BBoxUpdaterGroupingVisitor.h"
#include "BBoxUpdaterRenderingVisitor.h"
#include "BBoxUpdaterShapeVisitor.h"

#include <iostream>
using namespace std;

namespace X3DTK {
namespace X3D {

BBoxUpdater::BBoxUpdater()
: X3DBBoxUpdater()
{
  globalVariables = GVManager::getInstanceOf<BBoxUpdaterGlobalVariables>();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new BBoxUpdaterCoreVisitor());
  graphTraversal->setComponentVisitor(new BBoxUpdaterGeometry3DVisitor());
  graphTraversal->setComponentVisitor(new BBoxUpdaterGroupingVisitor());
  graphTraversal->setComponentVisitor(new BBoxUpdaterRenderingVisitor());
  graphTraversal->setComponentVisitor(new BBoxUpdaterShapeVisitor());
}

BBoxUpdater::~BBoxUpdater()
{
  GVManager::removeInstanceOf<BBoxUpdaterGlobalVariables>();

  delete graphTraversal;
}

void BBoxUpdater::update(SFNode N, bool staticProcessing)
{
  globalVariables->setStaticProcessing(staticProcessing);
  graphTraversal->traverse(N);
  globalVariables->finish();
}

}
}
