#include "BBoxUpdaterCoreVisitor.h"
#include "X3DNode.h"
#include "Scene.h"
#include "BBox.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

BBoxUpdaterCoreVisitor::BBoxUpdaterCoreVisitor()
: CoreVisitor()
{
  // WalkOn functions.
  defineNewWalkOnFunction(&BBoxUpdaterCoreVisitor::walkOnX3DNode);

  // Leave functions.
  defineNewLeaveFunction(&BBoxUpdaterCoreVisitor::leaveScene);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<BBoxUpdaterGlobalVariables>();
}

BBoxUpdaterCoreVisitor::~BBoxUpdaterCoreVisitor()
{
}

bool BBoxUpdaterCoreVisitor::walkOnX3DNode(X3DNode *, SFAbstractNode) const
{
  return false;
}

void BBoxUpdaterCoreVisitor::leaveScene(Scene *S) const
{
  BBox *BB = globalVariables->getBBox(S);
  if (BB == 0)
  {
    MFNode children = S->getChildren();
    for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
    {
      X3DBoundedObject *BO = dynamic_cast<X3DBoundedObject *>(*it);
      if (BO != 0)
        globalVariables->addBBoxToMergeList(BBox(BO->getBBoxCenter(), BO->getBBoxSize()));
    }
    BB = new BBox(globalVariables->mergeBBox()); 
    globalVariables->addBBox(S, BB);
    
    //updating the BBox attributes.
    S->setBBoxCenter(BB->getCenter());
    S->setBBoxSize(BB->getSize());
  }
}

}
}
