/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            BBoxUpdaterGroupingVisitor.h                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef BBOXUPDATERGROUPINGVISITOR_H
#define BBOXUPDATERGROUPINGVISITOR_H

#include "GroupingVisitor.h"
#include "BBoxUpdaterGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class StaticGroup;
class X3DGroupingNode;
class Group;
class Transform;
class Switch;

/// Visitor for the Grouping component of the BBoxUpdater module.

class BBoxUpdaterGroupingVisitor : public GroupingVisitor
{
public:
  /// Constructor.
  BBoxUpdaterGroupingVisitor();
  /// Destructor.
  virtual ~BBoxUpdaterGroupingVisitor();


  /// Walks on a StaticGroup.
  virtual bool walkOnStaticGroup(StaticGroup *S, SFAbstractNode Child) const;
  /// Walks on a X3DGroupingNode.
  virtual bool walkOnX3DGroupingNode(X3DGroupingNode *N, SFAbstractNode Child) const;

  /// Enters a StaticGroup.
  virtual void leaveStaticGroup(StaticGroup *S) const;
  /// Enters a X3DGroupingNode.
  virtual void leaveGroup(Group *G) const;
  /// Enters a Transform.
  virtual void leaveTransform(Transform *T) const;
  /// Enters a Switch.
  virtual void leaveSwitch(Switch *S) const;

protected:
  BBoxUpdaterGlobalVariables *globalVariables;
};

}
}

#endif
