#include "BBoxUpdaterShapeVisitor.h"
#include "X3DShapeNode.h"
#include "Shape.h"
#include "BBox.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

BBoxUpdaterShapeVisitor::BBoxUpdaterShapeVisitor()
: ShapeVisitor()
{
  // WalkOn functions.
  defineNewWalkOnFunction(&BBoxUpdaterShapeVisitor::walkOnX3DShapeNode);

  // Leave functions.
  defineNewLeaveFunction(&BBoxUpdaterShapeVisitor::leaveShape);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<BBoxUpdaterGlobalVariables>();
}

BBoxUpdaterShapeVisitor::~BBoxUpdaterShapeVisitor()
{
}

bool BBoxUpdaterShapeVisitor::walkOnX3DShapeNode(X3DShapeNode *, SFAbstractNode) const
{
  return true;
}

void BBoxUpdaterShapeVisitor::leaveShape(Shape *S) const
{
  BBox *BB = globalVariables->getBBox(S);
  if (BB == 0)
  {
    BB = new BBox(globalVariables->getShapeBBox());
    S->setBBoxCenter(BB->getCenter());
    S->setBBoxSize(BB->getSize());
    globalVariables->addBBox(S, BB); 
  }
}

}
}
