#include "GLBuilderGlobalVariables.h"

#include <algorithm>
#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

GLBuilderGlobalVariables::GLBuilderGlobalVariables()
: GlobalVariables(), _root(0)
{
}

GLBuilderGlobalVariables::~GLBuilderGlobalVariables()
{
}

void GLBuilderGlobalVariables::init()
{
  _root = 0;
  _nodeStack.push_front(0);
}

void GLBuilderGlobalVariables::finish()
{
  _nodeStack.clear();
  _nodeCoupleMap.clear();
}

void GLBuilderGlobalVariables::addCoupleNode(SFNode N, GL::SFNode GN)
{
  _nodeCoupleMap[N] = GN;  
  
  // init root node.
  if (_root == 0)
    _root = GN;
}

void GLBuilderGlobalVariables::pushNode(GL::SFNode N)
{
  GL::SFNode T = getTop();
  if (T != 0)
    T->addChild(N);
    
  // filling the stack.    
  _nodeStack.push_front(N);
}

void GLBuilderGlobalVariables::popNode()
{
  _nodeStack.pop_front();
}

GL::SFNode GLBuilderGlobalVariables::getNode(SFNode N) const
{
  map<SFNode, GL::SFNode>::const_iterator it = _nodeCoupleMap.find(N);
  if (it != _nodeCoupleMap.end())
    return (*it).second;
    
  return 0;  
}

}
}
