#include "MeshX3DMergerGlobalVariables.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

MeshX3DMergerGlobalVariables::MeshX3DMergerGlobalVariables()
{
}

MeshX3DMergerGlobalVariables::~MeshX3DMergerGlobalVariables()
{
}

void MeshX3DMergerGlobalVariables::init()
{
  _nodeStack.push_front(0);
  _itNode = _nodeList.begin();
  _exit = false;
}

void MeshX3DMergerGlobalVariables::finish()
{
  _nodeStack.clear();
}

void MeshX3DMergerGlobalVariables::setNodeList(std::list<MESH::SFNode> nodeList)
{
  _nodeList = nodeList;
}

void MeshX3DMergerGlobalVariables::pushParent(SFNode P)
{
  _nodeStack.push_front(P);
}

void MeshX3DMergerGlobalVariables::popParent()
{
  _nodeStack.pop_front();
}

void MeshX3DMergerGlobalVariables::setExit(bool value)
{
  _exit = value;
}

MESH::Transform *MeshX3DMergerGlobalVariables::getNextTransform()
{
  if (_itNode != _nodeList.end())
  {
    MESH::Transform *T = dynamic_cast<MESH::Transform *>(*_itNode);
    ++_itNode;
    return T;
  }
  
  return 0;  
}

MESH::Mesh *MeshX3DMergerGlobalVariables::getNextMesh()
{
  if (_itNode != _nodeList.end())
  {
    MESH::Mesh *M = dynamic_cast<MESH::Mesh *>(*_itNode);
    ++_itNode;
    return M;
  }
  
  return 0;  
}
  
}
}
