#include "WorldCoordTranslatorGroupingVisitor.h"
#include "Group.h"
#include "Transform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

WorldCoordTranslatorGroupingVisitor::WorldCoordTranslatorGroupingVisitor()
: GroupingVisitor()
{
  // Enter functions.
  defineNewEnterFunction(&WorldCoordTranslatorGroupingVisitor::enterTransform);
  
  // Leave functions.
  defineNewLeaveFunction(&WorldCoordTranslatorGroupingVisitor::leaveTransform);
  
  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<WorldCoordTranslatorGlobalVariables>();
}

WorldCoordTranslatorGroupingVisitor::~WorldCoordTranslatorGroupingVisitor()
{
}

void WorldCoordTranslatorGroupingVisitor::enterTransform(Transform *T) const
{
  SFMatrix34f transform(T->getTranslation(), T->getCenter(), T->getRotation(), T->getScaleOrientation(), T->getScale());
  
  T->setCenter(SFVec3f(0.0f, 0.0f, 0.0f));
  T->setRotation(SFRotation(0.0f, 0.0f, 1.0f, 0.0f));
  T->setScale(SFVec3f(1.0f, 1.0f, 1.0f));
  T->setScaleOrientation(SFRotation(0.0f, 0.0f, 1.0f, 0.0f));
  T->setTranslation(SFVec3f(0.0f, 0.0f, 0.0f));
  
  globalVariables->pushMatrix(transform);
}

void WorldCoordTranslatorGroupingVisitor::leaveTransform(Transform *) const
{
  globalVariables->popMatrix();
}

}
}
