#include "GraphTesterAbstractVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {

GraphTesterAbstractVisitor::GraphTesterAbstractVisitor()
{
  globalVariables = GVManager::getInstanceOf<GraphTesterGlobalVariables>();
  
  defineNewEnterFunction(&GraphTesterAbstractVisitor::enterX3DAbstractNode);
}

GraphTesterAbstractVisitor::~GraphTesterAbstractVisitor()
{
}

void GraphTesterAbstractVisitor::enterX3DAbstractNode(X3DAbstractNode *N) const
{
  cout << globalVariables->getTab() << N->getTypeName() << " = " << N << " -> ";
  MFAbstractNode list = N->getParents();
  for (MFAbstractNode::const_iterator it = list.begin(); it != list.end(); ++it)
    cout << (*it)->getTypeName() << ", ";
  cout << endl;
  
  globalVariables->addTab();
}

void GraphTesterAbstractVisitor::leaveX3DAbstractNode(X3DAbstractNode *N) const
{
  globalVariables->removeTab();
}

}
