#include "MemReleaser.h"
#include "DFSGraphTraversal.h"
#include "GL_DFSGraphTraversal.h"
#include "MESH_DFSGraphTraversal.h"
#include "MemReleaserAbstractVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {

MemReleaser::MemReleaser()
: X3DMemReleaser()
{
  globalVariables = GVManager::getInstanceOf<MemReleaserGlobalVariables>();

  //graphTraversal = mergeGraphTraversals(new X3D::DFSGraphTraversal(), new GL::DFSGraphTraversal());
  //graphTraversal = mergeGraphTraversals(graphTraversal, new MESH::DFSGraphTraversal());
  //graphTraversal = mergeGraphTraversals(new X3D::DFSGraphTraversal(), new MESH::DFSGraphTraversal());
  
  graphTraversal = new X3D::DFSGraphTraversal();
  
  graphTraversal->setComponentVisitor(new MemReleaserAbstractVisitor());
}

MemReleaser::~MemReleaser()
{
  GVManager::removeInstanceOf<MemReleaserGlobalVariables>();
  
  delete graphTraversal;
}

void MemReleaser::release(SFAbstractNode N) const
{
  globalVariables->init();
  graphTraversal->traverse(N);
  globalVariables->finish();
}

}
