#include "MemReleaserGlobalVariables.h"

namespace X3DTK {

MemReleaserGlobalVariables::MemReleaserGlobalVariables()
: GlobalVariables(), _toDelete(false)
{
}

MemReleaserGlobalVariables::~MemReleaserGlobalVariables()
{
}

void MemReleaserGlobalVariables::init()
{
  _nodeStack.push_front(0);
  _toDelete = false;
}

void MemReleaserGlobalVariables::finish()
{
  _nodeStack.clear();
}

void MemReleaserGlobalVariables::pushParent(SFAbstractNode P)
{
  _nodeStack.push_front(P);
}

void MemReleaserGlobalVariables::popParent()
{
  _nodeStack.pop_front();
}

void MemReleaserGlobalVariables::setDelete(bool value)
{
  _toDelete = value;
}

}
