/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            GL_X3DBuilder.h                                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DGLBUILDER_H
#define X3DGLBUILDER_H

#include "X3DNode.h"
#include "GL_Scene.h"
#include "GLSceneGraphTypes.h"
#include "X3DOnePassProcessor.h"

namespace X3DTK {
namespace X3D {

/// X3DGLBuilder concept.

class X3DGLBuilder : public X3DOnePassProcessor
{
public:
  /// Constructor.
  X3DGLBuilder();
  /// Destructor.
  virtual ~X3DGLBuilder() = 0;

  /// Converts N to a GL node.
  virtual GL::SFNode build(SFNode N) = 0;
  /// Returns the GL::Scene converted from S.
  GL::Scene *build(Scene *S);
};

}
}

#endif
