#include "SceneGraph.h"
#include "Component.h"

#include <algorithm>
#include <iostream>

using namespace std;
using namespace X3DTK;

MFSceneGraph SceneGraph::_sceneGraphList = MFSceneGraph();

SceneGraph::SceneGraph(const SFString &name)
: _name(name), _refCount(0), _componentList(MFComponent())
{
  //cout << "build SceneGraph " << name << ": " << this << endl;

  _sceneGraphList[name] = this;
}

SceneGraph::~SceneGraph()
{
  //cout << "destr SceneGraph " << _name << endl;
}

SceneGraph *SceneGraph::getSceneGraph(const SFString &name)
{
  MFSceneGraph::const_iterator it = _sceneGraphList.find(name); 
  if (it != _sceneGraphList.end())
    return (*it).second;
    
  //the type doesn't exist.
  return 0;  
}

void SceneGraph::addOneReference()
{
  ++_refCount;
  //cout << "add ref SceneGraph " << _name << " = " << _refCount << endl;
}

void SceneGraph::removeOneReference(SceneGraph *sceneGraph)
{
  --sceneGraph->_refCount;
  //cout << "remove ref SceneGraph " << SceneGraph->getName() << " = " << SceneGraph->_refCount << endl;
  
  if (sceneGraph->_refCount == 0)
  {
    // delete SceneGraph
    _sceneGraphList.erase(sceneGraph->_name);
    delete sceneGraph;
  }
}


void SceneGraph::addComponent(Component *component)
{
  _componentList[component->getName()] = component;
}
