#include "X3DAbstractNode.h"
#include "Type.h"

#include <algorithm>
#include <iostream>

using namespace std;

namespace X3DTK {

NameDict X3DAbstractNode::DEFDict = NameDict();

X3DAbstractNode::X3DAbstractNode()
: _type(0)
{    
  defineTypeName("X3DAbstractNode", "Abstract", "Abstract");
}

X3DAbstractNode::X3DAbstractNode(const X3DAbstractNode &N)
: _type(N._type), _parentList(N._parentList)
{
  addOneReference();
}

X3DAbstractNode::~X3DAbstractNode()
{
  /// Removes the instance for all the parents
  MFAbstractNode parentList = _parentList;
  for (MFAbstractNode::const_iterator it = parentList.begin(); it != parentList.end(); ++it)
    (*it)->removeChild(this);

  //this method is recursive and removes one instance for all the parents of
  //the type.
  Type::removeOneReference(_type);
  X3DAbstractNode::DEFDict.remove(this);
}

void X3DAbstractNode::addParent(const SFAbstractNode &N)
{
  if (N != 0)
    _parentList.push_back(N);
}

bool X3DAbstractNode::removeParent(const SFAbstractNode &N)
{
  if (N != 0)
  {
    MFAbstractNode::iterator res = find(_parentList.begin(), _parentList.end(), N);
    if (res != _parentList.end())
    {
      _parentList.erase(res);
      return true;
    }
  }
  return false;
}

bool X3DAbstractNode::addChild(const SFAbstractNode &)
{
  return false;
}

bool X3DAbstractNode::setChild(const SFAbstractNode &)
{
  cout << "X3DAbstractNode : set child" << endl;
  return false;
}

bool X3DAbstractNode::removeChild(const SFAbstractNode &)
{
  return false;
}

void X3DAbstractNode::addParentToChild(SFAbstractNode parent, SFAbstractNode child)
{
  if (child != 0)
    child->addParent(parent);
}

void X3DAbstractNode::removeParentFromChild(SFAbstractNode parent, SFAbstractNode child)
{
  if (child != 0)
    child->removeParent(parent);
}

}
