include(X3DToolKit.pri)
TEMPLATE = lib
TARGET = X3DTK
contains(DEFINES, XERCES) {
  CONFIG -= qt
} else {
contains(DEFINES, LIBXML) {
  CONFIG -= qt
} else {
  CONFIG *= qt
}
}
CONFIG *= opengl thread
win32:CONFIG += dll rtti
VERSION = 0.5.0

DESTDIR  = ../lib
OBJECTS_DIR = ../obj

INCLUDEPATH += ../include/X3DTK
INCLUDEPATH += ../include/X3DTK/private
win32:INCLUDEPATH += ../contrib/jpeg
win32:INCLUDEPATH += ../contrib/xerces-c_2_3_0-win32/include

HEADERS += functionalities/GL/GLRenderer/BBoxDrawArray.h
HEADERS += functionalities/GL/GLRenderer/GL_BBox.h
HEADERS += functionalities/GL/GLRenderer/GL_RendererCoreVisitor.h
HEADERS += functionalities/GL/GLRenderer/GL_RendererGlobalVariables.h
HEADERS += functionalities/GL/GLRenderer/GL_RendererGroupingVisitor.h
HEADERS += functionalities/GL/GLRenderer/GL_Renderer.h
HEADERS += functionalities/GL/GLUpdater/GL_UpdaterCoreVisitor.h
HEADERS += functionalities/GL/GLUpdater/GL_UpdaterGlobalVariables.h
HEADERS += functionalities/GL/GLUpdater/GL_Updater.h
HEADERS += functionalities/MESH/MeshNodeListBuilder/MeshNodeListBuilderCoreVisitor.h
HEADERS += functionalities/MESH/MeshNodeListBuilder/MeshNodeListBuilderGlobalVariables.h
HEADERS += functionalities/MESH/MeshNodeListBuilder/MeshNodeListBuilder.h
HEADERS += functionalities/MESH/MeshNormalUpdater/MeshNormalUpdaterCoreVisitor.h
HEADERS += functionalities/MESH/MeshNormalUpdater/MeshNormalUpdater.h
HEADERS += functionalities/other/commonProcessors/GL_X3DRenderer.h
HEADERS += functionalities/other/commonProcessors/GL_X3DUpdater.h
HEADERS += functionalities/other/commonProcessors/X3DBBoxUpdater.h
HEADERS += functionalities/other/commonProcessors/X3DFileValidator.h
HEADERS += functionalities/other/commonProcessors/X3DGLBuilder.h
HEADERS += functionalities/other/commonProcessors/X3DMemReleaser.h
HEADERS += functionalities/other/commonProcessors/X3DSceneSaver.h
HEADERS += functionalities/other/GraphTester/GraphTesterAbstractVisitor.h
HEADERS += functionalities/other/GraphTester/GraphTesterGlobalVariables.h
HEADERS += functionalities/other/GraphTester/GraphTester.h
HEADERS += functionalities/other/MemReleaser/MemReleaserAbstractVisitor.h
HEADERS += functionalities/other/MemReleaser/MemReleaserGlobalVariables.h
HEADERS += functionalities/other/MemReleaser/MemReleaser.h
HEADERS += functionalities/other/SimpleX3DGLScene/SimpleX3DGLScene.h
HEADERS += functionalities/X3D/BBoxUpdater/BBoxUpdaterCoreVisitor.h
HEADERS += functionalities/X3D/BBoxUpdater/BBoxUpdaterGeometry3DVisitor.h
HEADERS += functionalities/X3D/BBoxUpdater/BBoxUpdaterGlobalVariables.h
HEADERS += functionalities/X3D/BBoxUpdater/BBoxUpdaterGroupingVisitor.h
HEADERS += functionalities/X3D/BBoxUpdater/BBoxUpdater.h
HEADERS += functionalities/X3D/BBoxUpdater/BBoxUpdaterRenderingVisitor.h
HEADERS += functionalities/X3D/BBoxUpdater/BBoxUpdaterShapeVisitor.h
HEADERS += functionalities/X3D/GLBuilder/GLBuilderCoreVisitor.h
HEADERS += functionalities/X3D/GLBuilder/GLBuilderGeometry3DVisitor.h
HEADERS += functionalities/X3D/GLBuilder/GLBuilderGlobalVariables.h
HEADERS += functionalities/X3D/GLBuilder/GLBuilderGroupingVisitor.h
HEADERS += functionalities/X3D/GLBuilder/GLBuilder.h
HEADERS += functionalities/X3D/GLBuilder/GLBuilderRenderingVisitor.h
HEADERS += functionalities/X3D/GLBuilder/GLBuilderShapeVisitor.h
HEADERS += functionalities/X3D/GLBuilder/GLBuilderTexturingVisitor.h
HEADERS += functionalities/X3D/MeshBuilder/MeshBuilder.h
HEADERS += functionalities/X3D/MeshX3DMerger/MeshX3DMergerCoreVisitor.h
HEADERS += functionalities/X3D/MeshX3DMerger/MeshX3DMergerGeometry3DVisitor.h
HEADERS += functionalities/X3D/MeshX3DMerger/MeshX3DMergerGlobalVariables.h
HEADERS += functionalities/X3D/MeshX3DMerger/MeshX3DMergerGroupingVisitor.h
HEADERS += functionalities/X3D/MeshX3DMerger/MeshX3DMerger.h
HEADERS += functionalities/X3D/MeshX3DMerger/MeshX3DMergerRenderingVisitor.h
HEADERS += functionalities/X3D/SceneSaver/SceneSaverCoreVisitor.h
HEADERS += functionalities/X3D/SceneSaver/SceneSaverGlobalVariables.h
HEADERS += functionalities/X3D/SceneSaver/SceneSaver.h
HEADERS += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderCoreVisitor.h
HEADERS += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderGeometry3DVisitor.h
HEADERS += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderGlobalVariables.h
HEADERS += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderGroupingVisitor.h
HEADERS += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilder.h
HEADERS += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderRenderingVisitor.h
HEADERS += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderShapeVisitor.h
HEADERS += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderTraits.h
HEADERS += functionalities/X3D/WorldCoordTranslator/WorldCoordTranslatorGlobalVariables.h
HEADERS += functionalities/X3D/WorldCoordTranslator/WorldCoordTranslatorGroupingVisitor.h
HEADERS += functionalities/X3D/WorldCoordTranslator/WorldCoordTranslator.h
HEADERS += functionalities/X3D/WorldCoordTranslator/WorldCoordTranslatorRenderingVisitor.h
HEADERS += GLSceneGraph/base/GLSceneGraphTypes.h
HEADERS += GLSceneGraph/componentActors/GL_CoreVisitor.h
HEADERS += GLSceneGraph/componentActors/GL_DFSCoreWalker.h
HEADERS += GLSceneGraph/componentActors/GL_DFSGeometry3DWalker.h
HEADERS += GLSceneGraph/componentActors/GL_DFSGraphTraversal.h
HEADERS += GLSceneGraph/componentActors/GL_DFSGroupingWalker.h
HEADERS += GLSceneGraph/componentActors/GL_DFSRenderingWalker.h
HEADERS += GLSceneGraph/componentActors/GL_DFSShapeWalker.h
HEADERS += GLSceneGraph/componentActors/GL_DFSTexturingWalker.h
HEADERS += GLSceneGraph/componentActors/GL_Geometry3DVisitor.h
HEADERS += GLSceneGraph/componentActors/GL_GroupingVisitor.h
HEADERS += GLSceneGraph/componentActors/GL_RenderingVisitor.h
HEADERS += GLSceneGraph/componentActors/GL_ShapeVisitor.h
HEADERS += GLSceneGraph/componentActors/GL_TexturingVisitor.h
HEADERS += GLSceneGraph/nodes/Core/GL_Scene.h
HEADERS += GLSceneGraph/nodes/Core/GL_X3DNode.h
HEADERS += GLSceneGraph/nodes/Geometry3D/BoxDrawArray.h
HEADERS += GLSceneGraph/nodes/Geometry3D/ConeDrawArray.h
HEADERS += GLSceneGraph/nodes/Geometry3D/CylinderDrawArray.h
HEADERS += GLSceneGraph/nodes/Geometry3D/GL_Box.h
HEADERS += GLSceneGraph/nodes/Geometry3D/GL_Cone.h
HEADERS += GLSceneGraph/nodes/Geometry3D/GL_Cylinder.h
HEADERS += GLSceneGraph/nodes/Geometry3D/GL_IndexedFaceSet.h
HEADERS += GLSceneGraph/nodes/Geometry3D/GL_Sphere.h
HEADERS += GLSceneGraph/nodes/Geometry3D/SphereDrawArray.h
HEADERS += GLSceneGraph/nodes/Grouping/GL_Group.h
HEADERS += GLSceneGraph/nodes/Grouping/GL_StaticGroup.h
HEADERS += GLSceneGraph/nodes/Grouping/GL_Switch.h
HEADERS += GLSceneGraph/nodes/Grouping/GL_Transform.h
HEADERS += GLSceneGraph/nodes/Grouping/GL_X3DChildNode.h
HEADERS += GLSceneGraph/nodes/Grouping/GL_X3DGroupingNode.h
HEADERS += GLSceneGraph/nodes/Rendering/GL_IndexedLineSet.h
HEADERS += GLSceneGraph/nodes/Rendering/GL_PointSet.h
HEADERS += GLSceneGraph/nodes/Rendering/GL_TriangleFanSet.h
HEADERS += GLSceneGraph/nodes/Rendering/GL_TriangleSet.h
HEADERS += GLSceneGraph/nodes/Rendering/GL_TriangleStripSet.h
HEADERS += GLSceneGraph/nodes/Rendering/GL_X3DComposedGeometryNode.h
HEADERS += GLSceneGraph/nodes/Rendering/GL_X3DGeometry3DNode.h
HEADERS += GLSceneGraph/nodes/Rendering/GL_X3DGeometryNode.h
HEADERS += GLSceneGraph/nodes/Shape/GL_Appearance.h
HEADERS += GLSceneGraph/nodes/Shape/GL_FillProperties.h
HEADERS += GLSceneGraph/nodes/Shape/GL_LineProperties.h
HEADERS += GLSceneGraph/nodes/Shape/GL_Material.h
HEADERS += GLSceneGraph/nodes/Shape/GL_Shape.h
HEADERS += GLSceneGraph/nodes/Shape/GL_X3DAppearanceChildNode.h
HEADERS += GLSceneGraph/nodes/Shape/GL_X3DAppearanceNode.h
HEADERS += GLSceneGraph/nodes/Shape/GL_X3DMaterialNode.h
HEADERS += GLSceneGraph/nodes/Shape/GL_X3DShapeNode.h
HEADERS += GLSceneGraph/nodes/Texturing/GL_ImageTexture.h
HEADERS += GLSceneGraph/nodes/Texturing/GL_X3DTexture2DNode.h
HEADERS += GLSceneGraph/nodes/Texturing/GL_X3DTextureNode.h
HEADERS += GLSceneGraph/nodes/Texturing/GL_X3DTextureTransformNode.h
HEADERS += kernel/abstractNode/Component.h
HEADERS += kernel/abstractNode/NameDict.h
HEADERS += kernel/abstractNode/SceneGraph.h
HEADERS += kernel/abstractNode/Type.h
HEADERS += kernel/abstractNode/X3DAbstractNode.h
HEADERS += kernel/image/Image.h
HEADERS += kernel/image/JPGImageType.h
HEADERS += kernel/image/X3DImageType.h
HEADERS += kernel/processor/AbstractVisitor.h
HEADERS += kernel/processor/AbstractWalker.h
HEADERS += kernel/processor/EnterFunction.h
HEADERS += kernel/processor/GlobalVariables.h
HEADERS += kernel/processor/GraphTraversal.h
HEADERS += kernel/processor/GVManager.h
HEADERS += kernel/processor/LeaveFunction.h
HEADERS += kernel/processor/VisitingFunctions.h
HEADERS += kernel/processor/Visitor.h
HEADERS += kernel/processor/Walker.h
HEADERS += kernel/processor/WalkingFunction.h
HEADERS += kernel/processor/WalkOnFunction.h
HEADERS += kernel/processor/X3DActiveFunction.h
HEADERS += kernel/processor/X3DActor.h
HEADERS += kernel/processor/X3DComponent.h
HEADERS += kernel/processor/X3DComponentVisitor.h
HEADERS += kernel/processor/X3DComponentWalker.h
HEADERS += kernel/processor/X3DFunction.h
HEADERS += kernel/processor/X3DOnePassProcessor.h
HEADERS += kernel/processor/X3DProcessor.h
HEADERS += kernel/types/BBox.h
HEADERS += kernel/types/CLog.h
HEADERS += kernel/types/Platform.h
HEADERS += kernel/types/SFMatrix34f.h
HEADERS += kernel/types/SFPoint3f.h
HEADERS += kernel/types/SFString.h
HEADERS += kernel/types/SFVec2f.h
HEADERS += kernel/types/SFVec3f.h
HEADERS += kernel/types/X3DBaseTypes.h
HEADERS += kernel/types/X3DFileElement.h
HEADERS += kernel/types/X3DSceneGraphTypes.h
HEADERS += kernel/types/X3DTypes.h
HEADERS += kernel/types/X3DTypesToSFString.h
HEADERS += MeshSceneGraph/base/MeshSceneGraphTypes.h
HEADERS += MeshSceneGraph/base/TemplateDirectEdge.h
HEADERS += MeshSceneGraph/base/TemplateEdgeContent.h
HEADERS += MeshSceneGraph/base/TemplateEdge.h
HEADERS += MeshSceneGraph/base/TemplateFace.h
HEADERS += MeshSceneGraph/base/TemplateIndirectEdge.h
HEADERS += MeshSceneGraph/base/TemplateVertex.h
HEADERS += MeshSceneGraph/componentActors/MESH_CoreVisitor.h
HEADERS += MeshSceneGraph/componentActors/MESH_DFSCoreWalker.h
HEADERS += MeshSceneGraph/componentActors/MESH_DFSGraphTraversal.h
HEADERS += MeshSceneGraph/nodes/Core/MESH_Mesh.h
HEADERS += MeshSceneGraph/nodes/Core/MESH_Scene.h
HEADERS += MeshSceneGraph/nodes/Core/MESH_TemplateMesh.h
HEADERS += MeshSceneGraph/nodes/Core/MESH_Transform.h
HEADERS += MeshSceneGraph/nodes/Core/MESH_X3DGroupingNode.h
HEADERS += MeshSceneGraph/nodes/Core/MESH_X3DNode.h
HEADERS += X3DLoader/componentCreators/AbstractCreator.h
HEADERS += X3DLoader/componentCreators/CoreCreator.h
HEADERS += X3DLoader/componentCreators/Geometry3DCreator.h
HEADERS += X3DLoader/componentCreators/GroupingCreator.h
HEADERS += X3DLoader/componentCreators/InterpolationCreator.h
HEADERS += X3DLoader/componentCreators/LightingCreator.h
HEADERS += X3DLoader/componentCreators/NURBSCreator.h
HEADERS += X3DLoader/componentCreators/RenderingCreator.h
HEADERS += X3DLoader/componentCreators/ShapeCreator.h
HEADERS += X3DLoader/componentCreators/TexturingCreator.h
HEADERS += X3DLoader/CreationFunction.h
HEADERS += X3DLoader/Creator.h
HEADERS += X3DLoader/Loader.h
HEADERS += X3DLoader/X3DComponentCreator.h
HEADERS += X3DLoader/X3DLoader.h
HEADERS += X3DSceneGraph/base/X3DSceneGraphTypes.h
HEADERS += X3DSceneGraph/componentActors/CoreVisitor.h
HEADERS += X3DSceneGraph/componentActors/DFSCoreWalker.h
HEADERS += X3DSceneGraph/componentActors/DFSGeometry3DWalker.h
HEADERS += X3DSceneGraph/componentActors/DFSGraphTraversal.h
HEADERS += X3DSceneGraph/componentActors/DFSGroupingWalker.h
HEADERS += X3DSceneGraph/componentActors/DFSInterpolationWalker.h
HEADERS += X3DSceneGraph/componentActors/DFSLightingWalker.h
HEADERS += X3DSceneGraph/componentActors/DFSNURBSWalker.h
HEADERS += X3DSceneGraph/componentActors/DFSRenderingWalker.h
HEADERS += X3DSceneGraph/componentActors/DFSShapeWalker.h
HEADERS += X3DSceneGraph/componentActors/DFSTexturingWalker.h
HEADERS += X3DSceneGraph/componentActors/Geometry3DVisitor.h
HEADERS += X3DSceneGraph/componentActors/GroupingVisitor.h
HEADERS += X3DSceneGraph/componentActors/InterpolationVisitor.h
HEADERS += X3DSceneGraph/componentActors/LightingVisitor.h
HEADERS += X3DSceneGraph/componentActors/NURBSVisitor.h
HEADERS += X3DSceneGraph/componentActors/RenderingVisitor.h
HEADERS += X3DSceneGraph/componentActors/ShapeVisitor.h
HEADERS += X3DSceneGraph/componentActors/TexturingVisitor.h
HEADERS += X3DSceneGraph/nodes/Core/Scene.h
HEADERS += X3DSceneGraph/nodes/Core/X3DNode.h
HEADERS += X3DSceneGraph/nodes/Core/X3DObject.h
HEADERS += X3DSceneGraph/nodes/Geometry3D/Box.h
HEADERS += X3DSceneGraph/nodes/Geometry3D/Cone.h
HEADERS += X3DSceneGraph/nodes/Geometry3D/Cylinder.h
HEADERS += X3DSceneGraph/nodes/Geometry3D/IndexedFaceSet.h
HEADERS += X3DSceneGraph/nodes/Geometry3D/Sphere.h
HEADERS += X3DSceneGraph/nodes/Grouping/Group.h
HEADERS += X3DSceneGraph/nodes/Grouping/StaticGroup.h
HEADERS += X3DSceneGraph/nodes/Grouping/Switch.h
HEADERS += X3DSceneGraph/nodes/Grouping/Transform.h
HEADERS += X3DSceneGraph/nodes/Grouping/X3DBoundedObject.h
HEADERS += X3DSceneGraph/nodes/Grouping/X3DChildNode.h
HEADERS += X3DSceneGraph/nodes/Grouping/X3DGroupingNode.h
HEADERS += X3DSceneGraph/nodes/Interpolation/ColorInterpolator.h
HEADERS += X3DSceneGraph/nodes/Interpolation/CoordinateInterpolator2D.h
HEADERS += X3DSceneGraph/nodes/Interpolation/CoordinateInterpolator.h
HEADERS += X3DSceneGraph/nodes/Interpolation/NormalInterpolator.h
HEADERS += X3DSceneGraph/nodes/Interpolation/OrientationInterpolator.h
HEADERS += X3DSceneGraph/nodes/Interpolation/PositionInterpolator2D.h
HEADERS += X3DSceneGraph/nodes/Interpolation/PositionInterpolator.h
HEADERS += X3DSceneGraph/nodes/Interpolation/ScalarInterpolator.h
HEADERS += X3DSceneGraph/nodes/Interpolation/X3DInterpolatorNode.h
HEADERS += X3DSceneGraph/nodes/Lighting/DirectionalLight.h
HEADERS += X3DSceneGraph/nodes/Lighting/PointLight.h
HEADERS += X3DSceneGraph/nodes/Lighting/SpotLight.h
HEADERS += X3DSceneGraph/nodes/Lighting/X3DLightNode.h
HEADERS += X3DSceneGraph/nodes/NURBS/Contour2D.h
HEADERS += X3DSceneGraph/nodes/NURBS/ContourPolyline2D.h
HEADERS += X3DSceneGraph/nodes/NURBS/NurbsCurve2D.h
HEADERS += X3DSceneGraph/nodes/NURBS/NurbsCurve.h
HEADERS += X3DSceneGraph/nodes/NURBS/NurbsGroup.h
HEADERS += X3DSceneGraph/nodes/NURBS/NurbsPositionInterpolator.h
HEADERS += X3DSceneGraph/nodes/NURBS/NurbsSurface.h
HEADERS += X3DSceneGraph/nodes/NURBS/NurbsTextureSurface.h
HEADERS += X3DSceneGraph/nodes/NURBS/TrimmedSurface.h
HEADERS += X3DSceneGraph/nodes/NURBS/X3DParametricGeometryNode.h
HEADERS += X3DSceneGraph/nodes/Rendering/Color.h
HEADERS += X3DSceneGraph/nodes/Rendering/ColorRGBA.h
HEADERS += X3DSceneGraph/nodes/Rendering/Coordinate.h
HEADERS += X3DSceneGraph/nodes/Rendering/IndexedLineSet.h
HEADERS += X3DSceneGraph/nodes/Rendering/Normal.h
HEADERS += X3DSceneGraph/nodes/Rendering/PointSet.h
HEADERS += X3DSceneGraph/nodes/Rendering/TriangleFanSet.h
HEADERS += X3DSceneGraph/nodes/Rendering/TriangleSet.h
HEADERS += X3DSceneGraph/nodes/Rendering/TriangleStripSet.h
HEADERS += X3DSceneGraph/nodes/Rendering/X3DColorNode.h
HEADERS += X3DSceneGraph/nodes/Rendering/X3DComposedGeometryNode.h
HEADERS += X3DSceneGraph/nodes/Rendering/X3DCoordinateNode.h
HEADERS += X3DSceneGraph/nodes/Rendering/X3DGeometricPropertyNode.h
HEADERS += X3DSceneGraph/nodes/Rendering/X3DGeometry3DNode.h
HEADERS += X3DSceneGraph/nodes/Rendering/X3DGeometryNode.h
HEADERS += X3DSceneGraph/nodes/Rendering/X3DNormalNode.h
HEADERS += X3DSceneGraph/nodes/Shape/Appearance.h
HEADERS += X3DSceneGraph/nodes/Shape/FillProperties.h
HEADERS += X3DSceneGraph/nodes/Shape/LineProperties.h
HEADERS += X3DSceneGraph/nodes/Shape/Material.h
HEADERS += X3DSceneGraph/nodes/Shape/Shape.h
HEADERS += X3DSceneGraph/nodes/Shape/X3DAppearanceChildNode.h
HEADERS += X3DSceneGraph/nodes/Shape/X3DAppearanceNode.h
HEADERS += X3DSceneGraph/nodes/Shape/X3DMaterialNode.h
HEADERS += X3DSceneGraph/nodes/Shape/X3DShapeNode.h
HEADERS += X3DSceneGraph/nodes/Texturing/ImageTexture.h
HEADERS += X3DSceneGraph/nodes/Texturing/TextureCoordinate.h
HEADERS += X3DSceneGraph/nodes/Texturing/X3DTexture2DNode.h
HEADERS += X3DSceneGraph/nodes/Texturing/X3DTextureCoordinateNode.h
HEADERS += X3DSceneGraph/nodes/Texturing/X3DTextureNode.h
HEADERS += X3DSceneGraph/nodes/Texturing/X3DTextureTransformNode.h
SOURCES += functionalities/GL/GLRenderer/BBoxDrawArray.cpp
SOURCES += functionalities/GL/GLRenderer/GL_BBox.cpp
SOURCES += functionalities/GL/GLRenderer/GL_RendererCoreVisitor.cpp
SOURCES += functionalities/GL/GLRenderer/GL_Renderer.cpp
SOURCES += functionalities/GL/GLRenderer/GL_RendererGlobalVariables.cpp
SOURCES += functionalities/GL/GLRenderer/GL_RendererGroupingVisitor.cpp
SOURCES += functionalities/GL/GLUpdater/GL_UpdaterCoreVisitor.cpp
SOURCES += functionalities/GL/GLUpdater/GL_Updater.cpp
SOURCES += functionalities/GL/GLUpdater/GL_UpdaterGlobalVariables.cpp
SOURCES += functionalities/MESH/MeshNodeListBuilder/MeshNodeListBuilderCoreVisitor.cpp
SOURCES += functionalities/MESH/MeshNodeListBuilder/MeshNodeListBuilder.cpp
SOURCES += functionalities/MESH/MeshNodeListBuilder/MeshNodeListBuilderGlobalVariables.cpp
SOURCES += functionalities/MESH/MeshNormalUpdater/MeshNormalUpdaterCoreVisitor.cpp
SOURCES += functionalities/MESH/MeshNormalUpdater/MeshNormalUpdater.cpp
SOURCES += functionalities/other/commonProcessors/GL_X3DRenderer.cpp
SOURCES += functionalities/other/commonProcessors/GL_X3DUpdater.cpp
SOURCES += functionalities/other/commonProcessors/X3DBBoxUpdater.cpp
SOURCES += functionalities/other/commonProcessors/X3DFileValidator.cpp
SOURCES += functionalities/other/commonProcessors/X3DGLBuilder.cpp
SOURCES += functionalities/other/commonProcessors/X3DMemReleaser.cpp
SOURCES += functionalities/other/commonProcessors/X3DSceneSaver.cpp
SOURCES += functionalities/other/GraphTester/GraphTesterAbstractVisitor.cpp
SOURCES += functionalities/other/GraphTester/GraphTester.cpp
SOURCES += functionalities/other/GraphTester/GraphTesterGlobalVariables.cpp
SOURCES += functionalities/other/MemReleaser/MemReleaserAbstractVisitor.cpp
SOURCES += functionalities/other/MemReleaser/MemReleaser.cpp
SOURCES += functionalities/other/MemReleaser/MemReleaserGlobalVariables.cpp
SOURCES += functionalities/other/SimpleX3DGLScene/SimpleX3DGLScene.cpp
SOURCES += functionalities/X3D/BBoxUpdater/BBoxUpdaterCoreVisitor.cpp
SOURCES += functionalities/X3D/BBoxUpdater/BBoxUpdater.cpp
SOURCES += functionalities/X3D/BBoxUpdater/BBoxUpdaterGeometry3DVisitor.cpp
SOURCES += functionalities/X3D/BBoxUpdater/BBoxUpdaterGlobalVariables.cpp
SOURCES += functionalities/X3D/BBoxUpdater/BBoxUpdaterGroupingVisitor.cpp
SOURCES += functionalities/X3D/BBoxUpdater/BBoxUpdaterRenderingVisitor.cpp
SOURCES += functionalities/X3D/BBoxUpdater/BBoxUpdaterShapeVisitor.cpp
SOURCES += functionalities/X3D/GLBuilder/GLBuilderCoreVisitor.cpp
SOURCES += functionalities/X3D/GLBuilder/GLBuilder.cpp
SOURCES += functionalities/X3D/GLBuilder/GLBuilderGeometry3DVisitor.cpp
SOURCES += functionalities/X3D/GLBuilder/GLBuilderGlobalVariables.cpp
SOURCES += functionalities/X3D/GLBuilder/GLBuilderGroupingVisitor.cpp
SOURCES += functionalities/X3D/GLBuilder/GLBuilderRenderingVisitor.cpp
SOURCES += functionalities/X3D/GLBuilder/GLBuilderShapeVisitor.cpp
SOURCES += functionalities/X3D/GLBuilder/GLBuilderTexturingVisitor.cpp
SOURCES += functionalities/X3D/MeshBuilder/MeshBuilder.cpp
SOURCES += functionalities/X3D/MeshX3DMerger/MeshX3DMergerCoreVisitor.cpp
SOURCES += functionalities/X3D/MeshX3DMerger/MeshX3DMerger.cpp
SOURCES += functionalities/X3D/MeshX3DMerger/MeshX3DMergerGeometry3DVisitor.cpp
SOURCES += functionalities/X3D/MeshX3DMerger/MeshX3DMergerGlobalVariables.cpp
SOURCES += functionalities/X3D/MeshX3DMerger/MeshX3DMergerGroupingVisitor.cpp
SOURCES += functionalities/X3D/MeshX3DMerger/MeshX3DMergerRenderingVisitor.cpp
SOURCES += functionalities/X3D/SceneSaver/SceneSaverCoreVisitor.cpp
SOURCES += functionalities/X3D/SceneSaver/SceneSaver.cpp
SOURCES += functionalities/X3D/SceneSaver/SceneSaverGlobalVariables.cpp
SOURCES += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderCoreVisitor.cpp
SOURCES += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderGlobalVariables.cpp
SOURCES += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderGroupingVisitor.cpp
SOURCES += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderRenderingVisitor.cpp
SOURCES += functionalities/X3D/TemplateMeshBuilder/TemplateMeshBuilderShapeVisitor.cpp
SOURCES += functionalities/X3D/WorldCoordTranslator/WorldCoordTranslator.cpp
SOURCES += functionalities/X3D/WorldCoordTranslator/WorldCoordTranslatorGlobalVariables.cpp
SOURCES += functionalities/X3D/WorldCoordTranslator/WorldCoordTranslatorGroupingVisitor.cpp
SOURCES += functionalities/X3D/WorldCoordTranslator/WorldCoordTranslatorRenderingVisitor.cpp
SOURCES += GLSceneGraph/componentActors/GL_CoreVisitor.cpp
SOURCES += GLSceneGraph/componentActors/GL_DFSCoreWalker.cpp
SOURCES += GLSceneGraph/componentActors/GL_DFSGeometry3DWalker.cpp
SOURCES += GLSceneGraph/componentActors/GL_DFSGraphTraversal.cpp
SOURCES += GLSceneGraph/componentActors/GL_DFSGroupingWalker.cpp
SOURCES += GLSceneGraph/componentActors/GL_DFSRenderingWalker.cpp
SOURCES += GLSceneGraph/componentActors/GL_DFSShapeWalker.cpp
SOURCES += GLSceneGraph/componentActors/GL_DFSTexturingWalker.cpp
SOURCES += GLSceneGraph/componentActors/GL_Geometry3DVisitor.cpp
SOURCES += GLSceneGraph/componentActors/GL_GroupingVisitor.cpp
SOURCES += GLSceneGraph/componentActors/GL_RenderingVisitor.cpp
SOURCES += GLSceneGraph/componentActors/GL_ShapeVisitor.cpp
SOURCES += GLSceneGraph/componentActors/GL_TexturingVisitor.cpp
SOURCES += GLSceneGraph/nodes/Core/GL_Scene.cpp
SOURCES += GLSceneGraph/nodes/Core/GL_X3DNode.cpp
SOURCES += GLSceneGraph/nodes/Geometry3D/BoxDrawArray.cpp
SOURCES += GLSceneGraph/nodes/Geometry3D/ConeDrawArray.cpp
SOURCES += GLSceneGraph/nodes/Geometry3D/CylinderDrawArray.cpp
SOURCES += GLSceneGraph/nodes/Geometry3D/GL_Box.cpp
SOURCES += GLSceneGraph/nodes/Geometry3D/GL_Cone.cpp
SOURCES += GLSceneGraph/nodes/Geometry3D/GL_Cylinder.cpp
SOURCES += GLSceneGraph/nodes/Geometry3D/GL_IndexedFaceSet.cpp
SOURCES += GLSceneGraph/nodes/Geometry3D/GL_Sphere.cpp
SOURCES += GLSceneGraph/nodes/Geometry3D/SphereDrawArray.cpp
SOURCES += GLSceneGraph/nodes/Grouping/GL_Group.cpp
SOURCES += GLSceneGraph/nodes/Grouping/GL_StaticGroup.cpp
SOURCES += GLSceneGraph/nodes/Grouping/GL_Switch.cpp
SOURCES += GLSceneGraph/nodes/Grouping/GL_Transform.cpp
SOURCES += GLSceneGraph/nodes/Grouping/GL_X3DChildNode.cpp
SOURCES += GLSceneGraph/nodes/Grouping/GL_X3DGroupingNode.cpp
SOURCES += GLSceneGraph/nodes/Rendering/GL_IndexedLineSet.cpp
SOURCES += GLSceneGraph/nodes/Rendering/GL_PointSet.cpp
SOURCES += GLSceneGraph/nodes/Rendering/GL_TriangleFanSet.cpp
SOURCES += GLSceneGraph/nodes/Rendering/GL_TriangleSet.cpp
SOURCES += GLSceneGraph/nodes/Rendering/GL_TriangleStripSet.cpp
SOURCES += GLSceneGraph/nodes/Rendering/GL_X3DComposedGeometryNode.cpp
SOURCES += GLSceneGraph/nodes/Rendering/GL_X3DGeometry3DNode.cpp
SOURCES += GLSceneGraph/nodes/Rendering/GL_X3DGeometryNode.cpp
SOURCES += GLSceneGraph/nodes/Shape/GL_Appearance.cpp
SOURCES += GLSceneGraph/nodes/Shape/GL_FillProperties.cpp
SOURCES += GLSceneGraph/nodes/Shape/GL_LineProperties.cpp
SOURCES += GLSceneGraph/nodes/Shape/GL_Material.cpp
SOURCES += GLSceneGraph/nodes/Shape/GL_Shape.cpp
SOURCES += GLSceneGraph/nodes/Shape/GL_X3DAppearanceChildNode.cpp
SOURCES += GLSceneGraph/nodes/Shape/GL_X3DAppearanceNode.cpp
SOURCES += GLSceneGraph/nodes/Shape/GL_X3DMaterialNode.cpp
SOURCES += GLSceneGraph/nodes/Shape/GL_X3DShapeNode.cpp
SOURCES += GLSceneGraph/nodes/Texturing/GL_ImageTexture.cpp
SOURCES += GLSceneGraph/nodes/Texturing/GL_X3DTexture2DNode.cpp
SOURCES += GLSceneGraph/nodes/Texturing/GL_X3DTextureNode.cpp
SOURCES += GLSceneGraph/nodes/Texturing/GL_X3DTextureTransformNode.cpp
SOURCES += kernel/abstractNode/Component.cpp
SOURCES += kernel/abstractNode/NameDict.cpp
SOURCES += kernel/abstractNode/SceneGraph.cpp
SOURCES += kernel/abstractNode/Type.cpp
SOURCES += kernel/abstractNode/X3DAbstractNode.cpp
SOURCES += kernel/image/Image.cpp
SOURCES += kernel/image/JPGImageType.cpp
SOURCES += kernel/image/X3DImageType.cpp
SOURCES += kernel/processor/AbstractVisitor.cpp
SOURCES += kernel/processor/AbstractWalker.cpp
SOURCES += kernel/processor/EnterFunction.cpp
SOURCES += kernel/processor/GlobalVariables.cpp
SOURCES += kernel/processor/GraphTraversal.cpp
SOURCES += kernel/processor/GVManager.cpp
SOURCES += kernel/processor/LeaveFunction.cpp
SOURCES += kernel/processor/VisitingFunctions.cpp
SOURCES += kernel/processor/Visitor.cpp
SOURCES += kernel/processor/Walker.cpp
SOURCES += kernel/processor/WalkingFunction.cpp
SOURCES += kernel/processor/WalkOnFunction.cpp
SOURCES += kernel/processor/X3DActiveFunction.cpp
SOURCES += kernel/processor/X3DActor.cpp
SOURCES += kernel/processor/X3DComponent.cpp
SOURCES += kernel/processor/X3DComponentVisitor.cpp
SOURCES += kernel/processor/X3DComponentWalker.cpp
SOURCES += kernel/processor/X3DFunction.cpp
SOURCES += kernel/processor/X3DOnePassProcessor.cpp
SOURCES += kernel/processor/X3DProcessor.cpp
SOURCES += kernel/types/BBox.cpp
SOURCES += kernel/types/CLog.cpp
SOURCES += kernel/types/SFMatrix34f.cpp
SOURCES += kernel/types/SFPoint3f.cpp
SOURCES += kernel/types/SFString.cpp
SOURCES += kernel/types/SFVec2f.cpp
SOURCES += kernel/types/SFVec3f.cpp
SOURCES += kernel/types/X3DBaseTypes.cpp
SOURCES += kernel/types/X3DFileElement.cpp
SOURCES += kernel/types/X3DTypesToSFString.cpp
SOURCES += MeshSceneGraph/componentActors/MESH_CoreVisitor.cpp
SOURCES += MeshSceneGraph/componentActors/MESH_DFSCoreWalker.cpp
SOURCES += MeshSceneGraph/componentActors/MESH_DFSGraphTraversal.cpp
SOURCES += MeshSceneGraph/nodes/Core/MESH_Mesh.cpp
SOURCES += MeshSceneGraph/nodes/Core/MESH_Scene.cpp
SOURCES += MeshSceneGraph/nodes/Core/MESH_Transform.cpp
SOURCES += MeshSceneGraph/nodes/Core/MESH_X3DGroupingNode.cpp
SOURCES += MeshSceneGraph/nodes/Core/MESH_X3DNode.cpp
SOURCES += X3DLoader/componentCreators/AbstractCreator.cpp
SOURCES += X3DLoader/componentCreators/CoreCreator.cpp
SOURCES += X3DLoader/componentCreators/Geometry3DCreator.cpp
SOURCES += X3DLoader/componentCreators/GroupingCreator.cpp
SOURCES += X3DLoader/componentCreators/InterpolationCreator.cpp
SOURCES += X3DLoader/componentCreators/LightingCreator.cpp
SOURCES += X3DLoader/componentCreators/NURBSCreator.cpp
SOURCES += X3DLoader/componentCreators/RenderingCreator.cpp
SOURCES += X3DLoader/componentCreators/ShapeCreator.cpp
SOURCES += X3DLoader/componentCreators/TexturingCreator.cpp
SOURCES += X3DLoader/CreationFunction.cpp
SOURCES += X3DLoader/Creator.cpp
SOURCES += X3DLoader/Loader.cpp
SOURCES += X3DLoader/X3DComponentCreator.cpp
SOURCES += X3DLoader/X3DLoader.cpp
SOURCES += X3DSceneGraph/componentActors/CoreVisitor.cpp
SOURCES += X3DSceneGraph/componentActors/DFSCoreWalker.cpp
SOURCES += X3DSceneGraph/componentActors/DFSGeometry3DWalker.cpp
SOURCES += X3DSceneGraph/componentActors/DFSGraphTraversal.cpp
SOURCES += X3DSceneGraph/componentActors/DFSGroupingWalker.cpp
SOURCES += X3DSceneGraph/componentActors/DFSInterpolationWalker.cpp
SOURCES += X3DSceneGraph/componentActors/DFSLightingWalker.cpp
SOURCES += X3DSceneGraph/componentActors/DFSNURBSWalker.cpp
SOURCES += X3DSceneGraph/componentActors/DFSRenderingWalker.cpp
SOURCES += X3DSceneGraph/componentActors/DFSShapeWalker.cpp
SOURCES += X3DSceneGraph/componentActors/DFSTexturingWalker.cpp
SOURCES += X3DSceneGraph/componentActors/Geometry3DVisitor.cpp
SOURCES += X3DSceneGraph/componentActors/GroupingVisitor.cpp
SOURCES += X3DSceneGraph/componentActors/InterpolationVisitor.cpp
SOURCES += X3DSceneGraph/componentActors/LightingVisitor.cpp
SOURCES += X3DSceneGraph/componentActors/NURBSVisitor.cpp
SOURCES += X3DSceneGraph/componentActors/RenderingVisitor.cpp
SOURCES += X3DSceneGraph/componentActors/ShapeVisitor.cpp
SOURCES += X3DSceneGraph/componentActors/TexturingVisitor.cpp
SOURCES += X3DSceneGraph/nodes/Core/Scene.cpp
SOURCES += X3DSceneGraph/nodes/Core/X3DNode.cpp
SOURCES += X3DSceneGraph/nodes/Core/X3DObject.cpp
SOURCES += X3DSceneGraph/nodes/Geometry3D/Box.cpp
SOURCES += X3DSceneGraph/nodes/Geometry3D/Cone.cpp
SOURCES += X3DSceneGraph/nodes/Geometry3D/Cylinder.cpp
SOURCES += X3DSceneGraph/nodes/Geometry3D/IndexedFaceSet.cpp
SOURCES += X3DSceneGraph/nodes/Geometry3D/Sphere.cpp
SOURCES += X3DSceneGraph/nodes/Grouping/Group.cpp
SOURCES += X3DSceneGraph/nodes/Grouping/StaticGroup.cpp
SOURCES += X3DSceneGraph/nodes/Grouping/Switch.cpp
SOURCES += X3DSceneGraph/nodes/Grouping/Transform.cpp
SOURCES += X3DSceneGraph/nodes/Grouping/X3DBoundedObject.cpp
SOURCES += X3DSceneGraph/nodes/Grouping/X3DChildNode.cpp
SOURCES += X3DSceneGraph/nodes/Grouping/X3DGroupingNode.cpp
SOURCES += X3DSceneGraph/nodes/Interpolation/ColorInterpolator.cpp
SOURCES += X3DSceneGraph/nodes/Interpolation/CoordinateInterpolator2D.cpp
SOURCES += X3DSceneGraph/nodes/Interpolation/CoordinateInterpolator.cpp
SOURCES += X3DSceneGraph/nodes/Interpolation/NormalInterpolator.cpp
SOURCES += X3DSceneGraph/nodes/Interpolation/OrientationInterpolator.cpp
SOURCES += X3DSceneGraph/nodes/Interpolation/PositionInterpolator2D.cpp
SOURCES += X3DSceneGraph/nodes/Interpolation/PositionInterpolator.cpp
SOURCES += X3DSceneGraph/nodes/Interpolation/ScalarInterpolator.cpp
SOURCES += X3DSceneGraph/nodes/Interpolation/X3DInterpolatorNode.cpp
SOURCES += X3DSceneGraph/nodes/Lighting/DirectionalLight.cpp
SOURCES += X3DSceneGraph/nodes/Lighting/PointLight.cpp
SOURCES += X3DSceneGraph/nodes/Lighting/SpotLight.cpp
SOURCES += X3DSceneGraph/nodes/Lighting/X3DLightNode.cpp
SOURCES += X3DSceneGraph/nodes/NURBS/Contour2D.cpp
SOURCES += X3DSceneGraph/nodes/NURBS/ContourPolyline2D.cpp
SOURCES += X3DSceneGraph/nodes/NURBS/NurbsCurve2D.cpp
SOURCES += X3DSceneGraph/nodes/NURBS/NurbsCurve.cpp
SOURCES += X3DSceneGraph/nodes/NURBS/NurbsGroup.cpp
SOURCES += X3DSceneGraph/nodes/NURBS/NurbsPositionInterpolator.cpp
SOURCES += X3DSceneGraph/nodes/NURBS/NurbsSurface.cpp
SOURCES += X3DSceneGraph/nodes/NURBS/NurbsTextureSurface.cpp
SOURCES += X3DSceneGraph/nodes/NURBS/TrimmedSurface.cpp
SOURCES += X3DSceneGraph/nodes/NURBS/X3DParametricGeometryNode.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/Color.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/ColorRGBA.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/Coordinate.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/IndexedLineSet.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/Normal.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/PointSet.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/TriangleFanSet.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/TriangleSet.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/TriangleStripSet.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/X3DColorNode.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/X3DComposedGeometryNode.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/X3DCoordinateNode.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/X3DGeometricPropertyNode.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/X3DGeometry3DNode.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/X3DGeometryNode.cpp
SOURCES += X3DSceneGraph/nodes/Rendering/X3DNormalNode.cpp
SOURCES += X3DSceneGraph/nodes/Shape/Appearance.cpp
SOURCES += X3DSceneGraph/nodes/Shape/FillProperties.cpp
SOURCES += X3DSceneGraph/nodes/Shape/LineProperties.cpp
SOURCES += X3DSceneGraph/nodes/Shape/Material.cpp
SOURCES += X3DSceneGraph/nodes/Shape/Shape.cpp
SOURCES += X3DSceneGraph/nodes/Shape/X3DAppearanceChildNode.cpp
SOURCES += X3DSceneGraph/nodes/Shape/X3DAppearanceNode.cpp
SOURCES += X3DSceneGraph/nodes/Shape/X3DMaterialNode.cpp
SOURCES += X3DSceneGraph/nodes/Shape/X3DShapeNode.cpp
SOURCES += X3DSceneGraph/nodes/Texturing/ImageTexture.cpp
SOURCES += X3DSceneGraph/nodes/Texturing/TextureCoordinate.cpp
SOURCES += X3DSceneGraph/nodes/Texturing/X3DTexture2DNode.cpp
SOURCES += X3DSceneGraph/nodes/Texturing/X3DTextureCoordinateNode.cpp
SOURCES += X3DSceneGraph/nodes/Texturing/X3DTextureNode.cpp
SOURCES += X3DSceneGraph/nodes/Texturing/X3DTextureTransformNode.cpp

contains(DEFINES, LIBXML) {
  HEADERS += kernel/types/libXMLFileElement.h
  SOURCES += kernel/types/libXMLFileElement.cpp
  HEADERS += X3DLoader/libXMLLoader.h
  SOURCES += X3DLoader/libXMLLoader.cpp
}
contains(DEFINES, XERCES) {
  HEADERS += kernel/types/XercesFileElement.h
  SOURCES += kernel/types/XercesFileElement.cpp
  HEADERS += X3DLoader/XercesLoader.h
  SOURCES += X3DLoader/XercesLoader.cpp
}
contains(DEFINES, QT) {
  HEADERS += kernel/types/QFileElement.h
  SOURCES += kernel/types/QFileElement.cpp
  HEADERS += X3DLoader/QLoader.h
  SOURCES += X3DLoader/QLoader.cpp
}
